searchNodes=[{"doc":"","ref":"Example.html","title":"Example","type":"module"},{"doc":"","ref":"Example.html#double/1","title":"Example.double/1","type":"function"},{"doc":"Patch - Ergonomic Mocking for Elixir Patch makes it easy to mock one or more functions in a module returning a value or executing custom logic. Patches and Spies allow tests to assert or refute that function calls have been made. Patches When a module is patched, the patched function will return the value provided. assert &quot;HELLO&quot; = String.upcase(&quot;hello&quot;) # Assertion passes before patching patch(String, :upcase, :patched_return_value) assert :patched_return_value == String.upcase(&quot;hello&quot;) # Assertion passes after patching Modules can also be patched to run custom logic instead of returning a static value assert &quot;HELLO&quot; = String.upcase(&quot;hello&quot;) # Assertion passes before patching patch(String, :upcase, fn s -&gt; String.length(s) end) assert 5 == String.upcase(&quot;hello&quot;) # Assertion passes after patching Patching Ergonomics patch/3 returns the value that the patch will return which can be useful for later on in the test. Examine this example code for an example {:ok, expected} = patch(My.Module, :some_function, {:ok, 123}) ... additional testing code ... assert response.some_function_result == expected This allows the test author to combine creating fixture data with patching. Asserting / Refuting Calls After a patch is applied, tests can assert that an expected call has occurred by using the assert_called macro. patch(String, :upcase, :patched_return_value) assert :patched_return_value = String.upcase(&quot;hello&quot;) # Assertion passes after patching assert_called String.upcase(&quot;hello&quot;) # Assertion passes after call assert_called supports the :_ wildcard atom. In the above example the following assertion would also pass. assert_called String.upcase(:_) This can be useful when some of the arguments are complex or uninteresting for the unit test. Tests can also refute that a call has occurred with the refute_called macro. This macro works in much the same way as assert_called and also supports the :_ wildcard atom. Spies If a test wishes to assert / refute calls that happen to a module without actually changing the behavior of the module it can simply spy/1 the module. Spies behave identically to the original module but all calls and return values are recorded so assert_called and refute_called work as expected. Limitations Patch currently can only mock out functions of arity /0 - /10. If a function with greater arity needs to be patched this module will need to be updated.","ref":"Patch.html","title":"Patch","type":"module"},{"doc":"","ref":"Patch.html#assert_called/1","title":"Patch.assert_called/1","type":"macro"},{"doc":"Patches a function in a module The patched function will either always return the provided value or if a function is provided then the function will be called and its result returned.","ref":"Patch.html#patch/3","title":"Patch.patch/3","type":"function"},{"doc":"","ref":"Patch.html#refute_called/1","title":"Patch.refute_called/1","type":"macro"},{"doc":"","ref":"Patch.html#restore/1","title":"Patch.restore/1","type":"function"},{"doc":"Spies on the provided module Once a module has been spied on the calls to that module can be asserted / refuted without changing the behavior of the module.","ref":"Patch.html#spy/1","title":"Patch.spy/1","type":"function"},{"doc":"","ref":"Patch.MissingCall.html","title":"Patch.MissingCall","type":"exception"},{"doc":"","ref":"Patch.UnexpectedCall.html","title":"Patch.UnexpectedCall","type":"exception"},{"doc":"Patch Patch - Ergonomic Mocking for Elixir Patch makes it easy to mock one or more functions in a module returning a value or executing custom logic. Patches and Spies allow tests to assert or refute that function calls have been made.","ref":"readme.html","title":"Patch","type":"extras"},{"doc":"Add patch to your mix.exs def deps do [ {:patch, &quot;~&gt; 0.1&quot;, only: [:test]} ] end","ref":"readme.html#installation","title":"Patch - Installation","type":"extras"},{"doc":"After adding the dependency just add the following line to any test module after using your test case use Patch","ref":"readme.html#quickstart","title":"Patch - Quickstart","type":"extras"},{"doc":"When a module is patched, the patched function will return the value provided. assert &quot;HELLO&quot; = String.upcase(&quot;hello&quot;) # Assertion passes before patching patch(String, :upcase, :patched_return_value) assert :patched_return_value == String.upcase(&quot;hello&quot;) # Assertion passes after patching Modules can also be patched to run custom logic instead of returning a static value assert &quot;HELLO&quot; = String.upcase(&quot;hello&quot;) # Assertion passes before patching patch(String, :upcase, fn s -&gt; String.length(s) end) assert 5 == String.upcase(&quot;hello&quot;) # Assertion passes after patching Patching Ergonomics patch/3 returns the value that the patch will return which can be useful for later on in the test. Examine this example code for an example {:ok, expected} = patch(My.Module, :some_function, {:ok, 123}) ... additional testing code ... assert response.some_function_result == expected This allows the test author to combine creating fixture data with patching.","ref":"readme.html#patches","title":"Patch - Patches","type":"extras"},{"doc":"After a patch is applied, tests can assert that an expected call has occurred by using the assert_called macro. patch(String, :upcase, :patched_return_value) assert :patched_return_value = String.upcase(&quot;hello&quot;) # Assertion passes after patching assert_called String.upcase(&quot;hello&quot;) # Assertion passes after call assert_called supports the :_ wildcard atom. In the above example the following assertion would also pass. assert_called String.upcase(:_) This can be useful when some of the arguments are complex or uninteresting for the unit test. Tests can also refute that a call has occurred with the refute_called macro. This macro works in much the same way as assert_called and also supports the :_ wildcard atom.","ref":"readme.html#asserting-refuting-calls","title":"Patch - Asserting / Refuting Calls","type":"extras"},{"doc":"If a test wishes to assert / refute calls that happen to a module without actually changing the behavior of the module it can simply spy/1 the module. Spies behave identically to the original module but all calls and return values are recorded so assert_called and refute_called work as expected.","ref":"readme.html#spies","title":"Patch - Spies","type":"extras"},{"doc":"Patch currently can only mock out functions of arity /0 - /10. If a function with greater arity needs to be patched this module will need to be updated.","ref":"readme.html#limitations","title":"Patch - Limitations","type":"extras"}]